// feld.cpp
#include "feld.h"
#include <iostream>
bool Feld::ziehen(int spalte, char spieler) {
	if(spalte-1==0) {
		spielfeld[spalte-1][r0]=spieler; temp=r0; --r0; // Buchstabe in [Spalte][Reihe] eintragen, dann Reihe um 1 erhhen fr nchsten Buchstaben in dieser Spalte
	} else if(spalte-1==1) {
		spielfeld[spalte-1][r1]=spieler; temp=r1; --r1;
	} else if(spalte-1==2) {
		spielfeld[spalte-1][r2]=spieler; temp=r2; --r2;
	} else if(spalte-1==3) {
		spielfeld[spalte-1][r3]=spieler; temp=r3; --r3;
	} else if(spalte-1==4) {
		spielfeld[spalte-1][r4]=spieler; temp=r4; --r4;
	} else if(spalte-1==5) {
		spielfeld[spalte-1][r5]=spieler; temp=r5; --r5;
	} else if(spalte-1==6) {
		spielfeld[spalte-1][r6]=spieler; temp=r6; --r6;
	}	
}

bool Feld::pruefen(int spalte, char spieler) {
	bool gewonnen=false;
	// waagrecht
	for(int i=0;i<4;++i) {
		if(spielfeld[i][temp]==spieler && spielfeld[i+1][temp]==spieler &&
			spielfeld[i+2][temp]==spieler && spielfeld[i+3][temp]==spieler) {
				gewonnen=true;
				break;
		}
	}
	
	// senkrecht
	for(int i=0;i<3;++i) {
		if(spielfeld[spalte-1][i]==spieler && spielfeld[spalte-1][i+1]==spieler &&
			spielfeld[spalte-1][i+2]==spieler && spielfeld[spalte-1][i+3]==spieler) {
				gewonnen=true;
				break;
		}
	}
	
	// diagonal
	{ // Gltigkeitsbereich einschrnken, da j nur lokal
	
	int j=5;
	for(int i=0;i<4;++i) { // von links unten nach rechts oben
		while(j>2) {
			if(spielfeld[i][j]==spieler && spielfeld[i+1][j-1]==spieler &&
				spielfeld[i+2][j-2]==spieler && spielfeld[i+3][j-3]==spieler) {
					gewonnen=true;
					break;
					
			}
			--j;
		}
	}
	
	
	j=5;
	for(int i=6;i>2;--i) { // von rechts unten nach links oben
		while(j>2) {
			if(spielfeld[i][j]==spieler && spielfeld[i-1][j-1]==spieler &&
				spielfeld[i-2][j-2]==spieler && spielfeld[i-3][j-3]==spieler) {
					gewonnen=true;
					break;
			}
			--j;
		}
	}
	
	}
	
	if(gewonnen==true) { return true;}
	else if(gewonnen==false) { return false; }
}

void Feld::zeichnen(void) {
	for(int i=0;i<6;++i) {
		for(int j=0;j<7;++j) {
			std::cout<<spielfeld[j][i];
		}
		std::cout<<std::endl;
	}
	std::cout<<std::endl;
}

Feld::Feld(void) {
	for(int i=0;i<6;++i) {
		for(int j=0;j<7;++j) {
			spielfeld[j][i]='+';
		}
	}
	r0=5, r1=5, r2=5, r3=5, r4=5, r5=5, r6=5;
}
